package com.dk.mdm.infrastructure.util;

import org.apache.commons.lang.ObjectUtils;
import org.krysalis.barcode4j.HumanReadablePlacement;
import org.krysalis.barcode4j.impl.code128.Code128Bean;
import org.krysalis.barcode4j.output.bitmap.BitmapCanvasProvider;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.UUID;

/**
 * @author : 洪旭东
 * @desc : BarCodeUtil
 * @date : 2023-04-07 09:14
 */
public class BarCodeUtil {

    public static String create(String message, String path) {
        return create(message, path, 10.00, 0.3, true, false);
    }

    /**
     * 生成code128条形码
     *
     * @param height        条形码的高度
     * @param width         条形码的宽度
     * @param message       要生成的文本
     * @param withQuietZone 是否两边留白
     * @param hideText      隐藏可读文本
     * @return 图片对应的字节码
     */
    public static String create(String message, String path, Double height, Double width, boolean withQuietZone, boolean hideText) {
        // 条码保存的路径
//        String path = "D:\\2022-12-20 mes3.0";
        // 条码的图片名
        String codeName = UUID.randomUUID().toString();
        // 图片类型
        String imageType = "png";

        String fileName = path + codeName + "." + imageType;
        File file = new File(path, codeName + "." + imageType);
        FileOutputStream ous = null;
        try {
            ous = new FileOutputStream(file);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }

        Code128Bean bean = new Code128Bean();
        // 分辨率
        int dpi = 512;
        // 设置两侧是否留白
        bean.doQuietZone(withQuietZone);

        // 设置条形码高度和宽度
        bean.setBarHeight((double) ObjectUtils.defaultIfNull(height, 9.0D));
        if (width != null) {
            bean.setModuleWidth(width);
        }
        // 设置文本位置（包括是否显示）
        if (hideText) {
            bean.setMsgPosition(HumanReadablePlacement.HRP_NONE);
        }
        // 设置图片类型
        String format = "image/png";

        BitmapCanvasProvider canvas = new BitmapCanvasProvider(ous, format, dpi,
                BufferedImage.TYPE_BYTE_BINARY, false, 0);

        // 生产条形码
        bean.generateBarcode(canvas, message);
        try {
            canvas.finish();
        } catch (IOException e) {
            e.printStackTrace();
        }

        return fileName;
    }
}
